﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Importe für WCF
using System.ServiceModel;
using System.Runtime.Serialization;

namespace Rainbird.Examples.WcfDemo.Contracts
{
    /// <summary>
    /// Schnittstelle des Adressdienstes.
    /// </summary>
    [ServiceContract]
    public interface IAddressService
    {
        /// <summary>
        /// Gibt alle Adressen zurück.
        /// </summary>
        /// <returns>Tabelle mit Adressen</returns>
        [OperationContract]
        AddressDataSet GetAllAddresses();

        /// <summary>
        /// Gibt alle Adressen zurück, deren Nachname einem bestimmten Suchmuster entspricht.
        /// </summary>
        /// <param name="searchPattern">Suchmuster</param>
        /// <returns>Tabelle mit Adressen</returns>
        [OperationContract]
        AddressDataSet FindAddressesByLastName(string searchPattern);

        /// <summary>
        /// Speichert Adressen.
        /// </summary>
        /// <param name="changes">Tabelle mit zu speichernden Adressen</param>
        /// <returns>Gespeicherte Tabelle mit Adressen</returns>
        [OperationContract]
        AddressDataSet SaveAddresses(AddressDataSet changes);
    }
}
