﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Importe für WCF
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Runtime.Serialization;
using System.ServiceModel.Description;

// Importe für Kontrakte Dienste
using Rainbird.Examples.WcfDemo.Contracts;
using Rainbird.Examples.WcfDemo.Services;

namespace Rainbird.Examples.WcfDemo.Server
{
    /// <summary>
    /// Hauptprogramm.
    /// </summary>
    public class Program
    {
        /// <summary>
        /// Einstiegsfunktion.
        /// </summary>
        public static void Main()
        {
            // Diensthost erzeugen            
            ServiceHost host = new ServiceHost(typeof(AddressService), new Uri(@"http://localhost:8080/wcfdemo"));

            // WS-HTTP Bindung erzeugen
            WSHttpBinding binding = new WSHttpBinding(SecurityMode.Message);

            // Maximale Nachrichtengröße hochsetzen
            binding.MaxReceivedMessageSize = 6553600;

            // Endpunkt hinzufügen
            host.AddServiceEndpoint(typeof(IAddressService),    // Kontrakt 
                                    binding,                    // Bindung (WS-HTTP mit Verschlüsselten Nachrichten)
                                    "addressservice");          // Adresse

            // Dienstverhalten zur Veröffentlichung von Metadaten erstellen
            ServiceMetadataBehavior metaDataBehavoir = new ServiceMetadataBehavior();

            // WSDL über HTTP-GET Aufruf veröffentlichen
            metaDataBehavoir.HttpGetEnabled = true; 
            
            // Verhalten festlegen
            host.Description.Behaviors.Add(metaDataBehavoir);
            
            // Diensthost öffnen 
            host.Open();

            // Meldung ausgeben
            Console.WriteLine("WCF Server läuft.");

            // Auf Tastendruck warten
            Console.ReadKey(true);

            // Diensthost schließen
            host.Close();
        }
    }
}
