﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Runtime.Serialization;

namespace SimpleWcf.Contracts
{
    /// <summary>
    /// Dienstschnittstelle.
    /// </summary>
    [ServiceContract]
    public interface ICalcService
    {
        /// <summary>
        /// Addieren.
        /// </summary>
        /// <param name="request">Berechnungs-Anfrage-Nachricht</param>
        /// <returns>Ergebnis</returns>
        [OperationContract]
        int Add(AddRequest request);
    }

    /// <summary>
    /// Berecchnungs-Anfrage.
    /// </summary>
    [DataContract]
    public class AddRequest
    {
        /// <summary>
        /// Gibt Wert A zurück oder legt ihn fest.
        /// </summary>
        [DataMember]
        public int A
        {
            get;
            set;
        }

        /// <summary>
        /// Gibt Wert B zurück oder legt ihn fest.
        /// </summary>
        [DataMember]
        public int B
        {
            get;
            set;
        }
    }
}
