﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;
using SimpleWcf.Contracts;
using SimpleWcf.Services;
using System.ServiceModel.Description;

namespace SimpleWcf.Host
{
    /// <summary>
    /// Hauptprogramm.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einstiegsfunktion.
        /// </summary>
        static void Main()
        {
            // Diensthost erstellen
            ServiceHost host = new ServiceHost( 
                typeof(CalcService),                                // Typ des Dienstes der gehostet werden soll
                new Uri(@"net.tcp://localhost:8081/simplewcf"));    // Basis-URL
            
            // Binären TCP-Endpnkt registrieren
            host.AddServiceEndpoint(typeof(ICalcService),           // Dienstschnittstelle (Kontrakt)
                                    new NetTcpBinding(),            // Binäre TCP-Bindung
                                    "calcservice");                 // Dienst-Adresse

            // Host zum veröffentlichen von Metadaten konfigurieren
            host.Description.Behaviors.Add(new ServiceMetadataBehavior());
            
            // Endpunkt für Metadaten registrieren
            host.AddServiceEndpoint(typeof(IMetadataExchange), MetadataExchangeBindings.CreateMexTcpBinding(), "metadata");
                        
            // Diensthost öffnen (starten)
            host.Open();

            // Meldung ausgeben
            Console.WriteLine("Läuft ...");
            
            // Auf Tastendruck warten
            Console.ReadKey(true);

            // Diensthost schließen
            host.Close();
        }
    }
}
